NXOpen .NET Reference Guide  1899
 All Classes Namespaces Functions Variables Enumerations Enumerator Properties
Public Member Functions | List of all members
NXOpen.Routing.SBendCorner Class Reference

The Routing SBendCorner defines a S-Bend. More...

Inheritance diagram for NXOpen.Routing.SBendCorner:
NXOpen.NXObject NXOpen.TaggedObject NXOpen.INXObject NXOpen.Utilities.NXRemotableObject IMessageSink

Public Member Functions

unsafe bool GetSBendData (out int sbendType, out NXOpen.Routing.ControlPoint startRcp, out NXOpen.Routing.ControlPoint endRcp, out NXOpen.Routing.SplineSegment segment, out double radiusOrRatio)
 Returns the data for the S-Bend object More...
 
unsafe double GetSBendRadius ()
 Gets the S-Bend radius of a S-Bend corner. More...
 
unsafe NXOpen.Routing.Stock[] GetSBendStocks ()
 Returns an array of stocks for the S-Bend object More...
 
unsafe NXOpen.Routing.SplineSegment GetSegment ()
 Gets the segment being used to represent the S-Bend. More...
 
unsafe void SetSBendData (int sbendType, NXOpen.Routing.ControlPoint startRcp, NXOpen.Routing.ControlPoint endRcp, NXOpen.Routing.SplineSegment segment, double radiusOrRatio, bool useBendRatio)
 Set the data for the S-Bend object More...
 
- Public Member Functions inherited from NXOpen.NXObject
unsafe NXOpen.AttributeIterator CreateAttributeIterator ()
 Create an attribute iterator More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type)
 Deletes all attributes of a specific type. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes all attributes of a specific type with the option to update or not. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title)
 Deletes an attribute by type and title. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title, NXOpen.Update.Option option)
 Deletes an attribute by type and title with the option to update or not. More...
 
unsafe void DeleteUserAttribute (NXOpen.NXObject.AttributeType type, string title, bool deleteEntireArray, NXOpen.Update.Option option)
 Deletes the first attribute encountered with the given Type, Title. More...
 
unsafe void DeleteUserAttributes (NXOpen.AttributeIterator iterator, NXOpen.Update.Option option)
 Deletes the attributes on the object, if any, that satisfy the given iterator More...
 
unsafe void DeleteUserAttributes (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes the attributes encountered with the given Type with option to update or not. More...
 
unsafe NXOpen.INXObject FindObject (string journalIdentifier)
 Finds the NXOpen.NXObject with the given identifier as recorded in a journal. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetAttributeTitlesByType (NXOpen.NXObject.AttributeType type)
 Gets all the attribute titles of a specific type. More...
 
unsafe bool GetBooleanUserAttribute (string title, int index)
 Gets a boolean attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.ComputationalTime 
GetComputationalTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe int GetIntegerAttribute (string title)
 Gets an integer attribute by title. More...
 
unsafe int GetIntegerUserAttribute (string title, int index)
 Gets an integer attribute by Title and array Index. More...
 
unsafe bool GetNextUserAttribute (NXOpen.AttributeIterator iterator, out NXOpen.NXObject.AttributeInformation info)
 Gets the next attribute encountered on the object, if any, that satisfies the given iterator. More...
 
unsafe string GetPdmReferenceAttributeValue (string attributeTitle)
 Gets the value of PDM Reference attribute for given object. More...
 
unsafe double GetRealAttribute (string title)
 Gets a real attribute by title. More...
 
unsafe double GetRealUserAttribute (string title, int index)
 Gets a real attribute by Title and array Index. More...
 
unsafe string GetReferenceAttribute (string title)
 Gets the reference string (not the calculated value) of a string attribute that uses a reference string. More...
 
unsafe string GetStringAttribute (string title)
 Gets a string attribute value by title. More...
 
unsafe string GetStringUserAttribute (string title, int index)
 Gets a string attribute by Title and array Index. More...
 
unsafe string GetTimeAttribute (NXOpen.NXObject.DateAndTimeFormat format, string title)
 Gets a time attribute by title. More...
 
unsafe string GetTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.AttributeInformation 
GetUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttribute (string title, bool includeUnset, bool addStringValues, NXOpen.NXObject.AttributeType type)
 Gets the first attribute (or attribute array) encountered on the object, if any, with a given Title and Type. More...
 
unsafe string GetUserAttributeAsString (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given title, type and array index. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator, bool countArrayAsOneAttribute)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type)
 Gets the count of set attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type, bool includeUnset, bool countArrayAsOneAttribute)
 Gets the count of attributes on the object, if any, of the given type. More...
 
unsafe bool GetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type)
 Determine the lock of the given attribute. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (NXOpen.AttributeIterator iterator)
 Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset)
 Gets all the attributes of the given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset, bool addStringValues)
 Gets all the attributes of the given object. More...
 
unsafe string[] GetUserAttributesAsStrings ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe int GetUserAttributeSize (string title, NXOpen.NXObject.AttributeType type)
 Gets the size of the first attribute encountered on the object, if any, with a given Title and Type. More...
 
unsafe NXOpen.NXObject[] GetUserAttributeSourceObjects ()
 Returns an array of objects from which this object presents attributes. More...
 
unsafe bool HasUserAttribute (NXOpen.AttributeIterator iterator)
 Determines if an attribute exists on the object, that satisfies the given iterator More...
 
unsafe bool HasUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Determines if an attribute with the given Title, Type and array Index is present on the object Unset attributes will not be detected by this function, as its purpose is to test for the actual presence of the attribute on the object. More...
 
unsafe void Print ()
 Prints a representation of this object to the system log file. More...
 
unsafe void SetAttribute (string title, int value)
 Creates or modifies an integer attribute. More...
 
unsafe void SetAttribute (string title, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, double value)
 Creates or modifies a real attribute. More...
 
unsafe void SetAttribute (string title, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, string value)
 Creates or modifies a string attribute. More...
 
unsafe void SetAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title)
 Creates or modifies a null attribute which is an attribute with a title and no value. More...
 
unsafe void SetAttribute (string title, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetBooleanUserAttribute (string title, int index, bool value, NXOpen.Update.Option option)
 Creates or modifies a boolean attribute with the option to update or not. More...
 
unsafe void SetName (string name)
 Sets the custom name of the object. More...
 
unsafe void SetPdmReferenceAttribute (string attributeTitle, string attributeValue)
 Sets the value of PDM Reference attribute on the object. More...
 
unsafe void SetReferenceAttribute (string title, string value)
 Creates or modifies a string attribute which uses a reference string. More...
 
unsafe void SetReferenceAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute which uses a reference string, with the option to update or not. More...
 
unsafe void SetTimeAttribute (string title, string value)
 Creates or modifies a time attribute. More...
 
unsafe void SetTimeAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, NXOpen.NXObject.ComputationalTime value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (NXOpen.NXObject.AttributeInformation info, NXOpen.Update.Option option)
 Creates or modifies an attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type, bool @lock)
 Lock or unlock the given attribute. More...
 
- Public Member Functions inherited from NXOpen.TaggedObject
void PrintTestData (String variableName)
 <exclude> More...
 
void PrintTestData (String variableName, int lineNumber)
 <exclude> More...
 
override string ToString ()
 Returns a String that represents the current Object. More...
 
- Public Member Functions inherited from NXOpen.Utilities.NXRemotableObject
IMessageCtrl AsyncProcessMessage (IMessage msg, IMessageSink replySink)
 Asynchronously processes the given message. More...
 
IMessage SyncProcessMessage (IMessage msg)
 Synchronously processes the given message. More...
 

Additional Inherited Members

- Public Types inherited from NXOpen.NXObject
enum  AttributeType {
  Invalid, Null, Boolean, Integer,
  Real, String, Time, Reference,
  Any = 100
}
 Specifies attribute type. More...
 
enum  DateAndTimeFormat { Numeric, Textual }
 Specifies the format of the date and time attribute. More...
 
- Protected Member Functions inherited from NXOpen.TaggedObject
new void initialize ()
 <exclude> More...
 
- Properties inherited from NXOpen.NXObject
unsafe bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
unsafe string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
unsafe string Name [get]
 Returns the custom name of the object. More...
 
unsafe NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
unsafe NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
unsafe NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 

Detailed Description

The Routing SBendCorner defines a S-Bend.

There are 5 possible S-bend types.

The UI input is two work part line segment-ending RCPs, each of which implicitly provides a 3D point and vector. An S-bend heals the separation between the two segments with a C1 continuous spline segment.

To disambiguate among 5 S-bend types (see below), the user may need to further indicate whether the S-bend starts bending immediately at the end of one or both of the 2 input segments. Some arrangements of 2 segments do not require further user input to disambiguate among the possible S-bend types.

The direction vectors of the 2 input segments must either be perpendicular (types 1,2,3) or parallel (types 4,5).

The closest distance between the (infinite) lines containing the input segments must be less that twice the bend radius. If this condition does not hold, then 2 right angle bends could connect the 2 input segments, i.e., an S-bend is unnecessary.

Every S-bend has two bends, whose radii are always equal. Except for type 2 and 3, the bend angles are equal and in the range [ Pi/4, Pi/2 ].

S-bends never cause a cutback of an input segment, although type 1,2,4 S-bends may add a straight line extension to one of the segment ends before the bending starts. Type 1 S-bends may add a straight line extension to both segment ends.

INPUT

For computation solving purposes, the above input becomes a bend radius, height, width, and possibly a depth.

OUTPUT bend angle(s):

Bend angles are computed at the centers of the bend arcs

S-bends fall into two categories:

The constructor line, AB, is the perpendicular distance between the lines that the segments define.

The A-B, A-P1, B-P2 vectors are mutually perpendicular.

Segment 2 may also have to extend toward B before its bend starts.

Geometrically, the height is the sum of the vertical components of bend 1 and bend 2.

Type 2: middle straight line portion

/
/ seg1
P1 /
*
/
/
/
/ /
/ :
A / :
| :
| \
| \ &lt;&mdash;- straight segment
| \
| \ &lt;&mdash;&ndash; bend ends
| `-,
| ``-,_
+&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;`-*&mdash;&mdash;&mdash;&mdash;
B P2 seg2

Similar to Type 1:

The bend from segment 2 lies in the plane A,B,P2.

The bend from segment 1 is always 90 degrees, and thus terminates somewhere in the plane A,B,P2.

The bend from segment 1 always starts on an extension of segment 1 that is a distance R from A.

Unlike Type 1:

Segment 2's bend always starts at P2, i.e., segment 2 never has an extension.

Type 3: middle straight line portion. user chooses between Type 2-3.

/
/ seg1
P1 /
*
/ '
/ '
/ : &lt;&mdash;- segment 1's bend ends
/ |
/ |
A / |
| | &lt;&mdash; straight segment
| |
| |
| |
| |
| \ &lt;&mdash;- segment 2's bend ends
| `-,_
+&mdash;&mdash;&mdash;&mdash;&mdash;-`-*&mdash;&mdash;&mdash;&mdash;
B P2 seg2

The bend radius isn't big enough to span the height so a middle straight line segment is necessary.

Neither segment can have an extension, i.e., the bends start at P1 and P2. Unlike in Type 2, segment 2's bend does not lie in the plane A,B,P2, i.e., both bends immediately start bending toward each other.

End tangents are parallel, i.e., bend lies entirely within a plane. This category falls into two types.

Because both bend angles are the same, the bends meet at half the height H/2.

Type 5: middle straight line portion

seg1 P1
&mdash;&mdash;&mdash;&mdash;*-.
`.
\
\ &lt;&mdash; middle straight line segment
\
`.
`-*&mdash;&mdash;&mdash;&mdash;
A P2 seg2

The height, H, is length (A-P1), where A is the projection of P1 onto the line that seg2 defines. The width, W, is the A-P2 length.

Support Information:

===============================

o An extension as described above is the distance leading up to the bend arc.

Use the NXOpen.Routing.SBendCornerCollection to obtain an instance.

Created in NX4.0.0

Member Function Documentation

unsafe bool NXOpen.Routing.SBendCorner.GetSBendData ( out int  sbendType,
out NXOpen.Routing.ControlPoint  startRcp,
out NXOpen.Routing.ControlPoint  endRcp,
out NXOpen.Routing.SplineSegment  segment,
out double  radiusOrRatio 
)
inline

Returns the data for the S-Bend object

Created in NX4.0.0

License requirements: routing_base ("Routing Basic")

Parameters
sbendTypeS-Bend type
startRcpS-Bend start Control point
endRcpS-Bend end Control point
segmentS-Bend segment
radiusOrRatioBend radius or bend_ratio.
Returns
TRUE: if bend ratio is used; FALSE: otherwise.
unsafe double NXOpen.Routing.SBendCorner.GetSBendRadius ( )
inline

Gets the S-Bend radius of a S-Bend corner.

Created in NX4.0.0

License requirements: routing_base ("Routing Basic")

Returns
unsafe NXOpen.Routing.Stock [] NXOpen.Routing.SBendCorner.GetSBendStocks ( )
inline

Returns an array of stocks for the S-Bend object

Created in NX4.0.0

License requirements: routing_base ("Routing Basic")

Returns
Stock objects of the S-Bend corner.
unsafe NXOpen.Routing.SplineSegment NXOpen.Routing.SBendCorner.GetSegment ( )
inline

Gets the segment being used to represent the S-Bend.

Created in NX4.0.0

License requirements: routing_base ("Routing Basic")

Returns
unsafe void NXOpen.Routing.SBendCorner.SetSBendData ( int  sbendType,
NXOpen.Routing.ControlPoint  startRcp,
NXOpen.Routing.ControlPoint  endRcp,
NXOpen.Routing.SplineSegment  segment,
double  radiusOrRatio,
bool  useBendRatio 
)
inline

Set the data for the S-Bend object

Created in NX4.0.0

License requirements: routing_base ("Routing Basic")

Parameters
sbendTypeS-Bend type
startRcpThe start Control point for the S-Bend.
endRcpThe end Control point for the S-Bend.
segmentS-Bend segment
radiusOrRatioS-Bend radius or bend_ratio.
useBendRatioTRUE: if bend ratio is used; FALSE: otherwise.

The documentation for this class was generated from the following file:
Copyright 2019 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.